import type { IColor, IRgb, IRgba, IHsl, IHsla, IHsv, IHsva } from "../Core/Interfaces/Colors";
import type { IImage } from "../Core/Interfaces/IImage";
import type { IParticle } from "../Core/Interfaces/IParticle";
import type { IParticleHslAnimation } from "../Core/Interfaces/IParticleHslAnimation";
export declare function colorToRgb(input?: string | IColor, index?: number, useIndex?: boolean): IRgb | undefined;
export declare function colorToHsl(color: string | IColor | undefined, index?: number, useIndex?: boolean): IHsl | undefined;
export declare function rgbToHsl(color: IRgb): IHsl;
export declare function stringToAlpha(input: string): number | undefined;
export declare function stringToRgb(input: string): IRgb | undefined;
export declare function hslToRgb(hsl: IHsl): IRgb;
export declare function hslaToRgba(hsla: IHsla): IRgba;
export declare function hslToHsv(hsl: IHsl): IHsv;
export declare function hslaToHsva(hsla: IHsla): IHsva;
export declare function hsvToHsl(hsv: IHsv): IHsl;
export declare function hsvaToHsla(hsva: IHsva): IHsla;
export declare function hsvToRgb(hsv: IHsv): IRgb;
export declare function hsvaToRgba(hsva: IHsva): IRgba;
export declare function rgbToHsv(rgb: IRgb): IHsv;
export declare function rgbaToHsva(rgba: IRgba): IHsva;
export declare function getRandomRgbColor(min?: number): IRgb;
export declare function getStyleFromRgb(color: IRgb, opacity?: number): string;
export declare function getStyleFromHsl(color: IHsl, opacity?: number): string;
export declare function getStyleFromHsv(color: IHsv, opacity?: number): string;
export declare function colorMix(color1: IRgb | IHsl, color2: IRgb | IHsl, size1: number, size2: number): IRgb;
export declare function replaceColorSvg(image: IImage, color: IHsl, opacity: number): string;
export declare function getLinkColor(p1: IParticle, p2?: IParticle, linkColor?: string | IRgb): IRgb | undefined;
export declare function getLinkRandomColor(optColor: string | IColor, blink: boolean, consent: boolean): IRgb | string | undefined;
export declare function getHslFromAnimation(animation?: IParticleHslAnimation): IHsl | undefined;
export declare class ColorUtils {
    static colorToRgb(input?: string | IColor, index?: number, useIndex?: boolean): IRgb | undefined;
    static colorToHsl(color: string | IColor | undefined, index?: number, useIndex?: boolean): IHsl | undefined;
    static rgbToHsl(color: IRgb): IHsl;
    static stringToAlpha(input: string): number | undefined;
    static stringToRgb(input: string): IRgb | undefined;
    static hslToRgb(hsl: IHsl): IRgb;
    static hslaToRgba(hsla: IHsla): IRgba;
    static hslToHsv(hsl: IHsl): IHsv;
    static hslaToHsva(hsla: IHsla): IHsva;
    static hsvToHsl(hsv: IHsv): IHsl;
    static hsvaToHsla(hsva: IHsva): IHsla;
    static hsvToRgb(hsv: IHsv): IRgb;
    static hsvaToRgba(hsva: IHsva): IRgba;
    static rgbToHsv(rgb: IRgb): IHsv;
    static rgbaToHsva(rgba: IRgba): IHsva;
    static getRandomRgbColor(min?: number): IRgb;
    static getStyleFromRgb(color: IRgb, opacity?: number): string;
    static getStyleFromHsl(color: IHsl, opacity?: number): string;
    static getStyleFromHsv(color: IHsv, opacity?: number): string;
    static mix(color1: IRgb | IHsl, color2: IRgb | IHsl, size1: number, size2: number): IRgb;
    static replaceColorSvg(image: IImage, color: IHsl, opacity: number): string;
    static getLinkColor(p1: IParticle, p2?: IParticle, linkColor?: string | IRgb): IRgb | undefined;
    static getLinkRandomColor(optColor: string | IColor, blink: boolean, consent: boolean): IRgb | string | undefined;
    static getHslFromAnimation(animation?: IParticleHslAnimation): IHsl | undefined;
}
