import { isInArray } from "../../Utils";
import { ExternalBase } from "./ExternalBase";
export class Lighter extends ExternalBase {
    constructor(container) {
        super(container, "lighter");
    }
    interact() {
        const container = this.container;
        const options = container.options;
        if (options.interactivity.events.onHover.enable && container.interactivity.status === "mousemove") {
            const mousePos = container.interactivity.mouse.position;
            if (!mousePos) {
                return;
            }
            container.canvas.drawLight(mousePos);
        }
    }
    isEnabled() {
        const container = this.container;
        const mouse = container.interactivity.mouse;
        const events = container.options.interactivity.events;
        if (!(events.onHover.enable && mouse.position)) {
            return false;
        }
        const hoverMode = events.onHover.mode;
        return isInArray("light", hoverMode);
    }
    reset() {
    }
}
