import { isInArray } from "../../Utils";
import { ParticlesBase } from "./ParticlesBase";
export class Lighter extends ParticlesBase {
    constructor(container) {
        super(container, "lighter");
    }
    interact(particle) {
        const container = this.container;
        const options = container.options;
        if (options.interactivity.events.onHover.enable && container.interactivity.status === "mousemove") {
            const mousePos = this.container.interactivity.mouse.position;
            if (mousePos) {
                container.canvas.drawParticleShadow(particle, mousePos);
            }
        }
    }
    isEnabled() {
        const container = this.container;
        const mouse = container.interactivity.mouse;
        const events = container.options.interactivity.events;
        if (!(events.onHover.enable && mouse.position)) {
            return false;
        }
        const hoverMode = events.onHover.mode;
        return isInArray("light", hoverMode);
    }
    reset() {
    }
}
