import { randomInRange } from "../Utils";
export class StrokeColorUpdater {
    constructor(container) {
        this.container = container;
    }
    isEnabled(particle) {
        var _a, _b, _c;
        const color = particle.stroke.color;
        return (!particle.destroyed &&
            !particle.spawning &&
            color !== undefined &&
            ((((_a = particle.strokeColor) === null || _a === void 0 ? void 0 : _a.h.value) !== undefined && color.animation.h.enable) ||
                (((_b = particle.strokeColor) === null || _b === void 0 ? void 0 : _b.s.value) !== undefined && color.animation.s.enable) ||
                (((_c = particle.strokeColor) === null || _c === void 0 ? void 0 : _c.l.value) !== undefined && color.animation.l.enable)));
    }
    update(particle, delta) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        if (!this.isEnabled(particle)) {
            return;
        }
        const animationOptions = particle.stroke.color.animation;
        const valueAnimations = animationOptions;
        if (valueAnimations.enable !== undefined) {
            const hue = (_b = (_a = particle.strokeColor) === null || _a === void 0 ? void 0 : _a.h) !== null && _b !== void 0 ? _b : (_c = particle.color) === null || _c === void 0 ? void 0 : _c.h;
            if (hue) {
                this.updateValue(particle, delta, hue, valueAnimations, 360);
            }
        }
        else {
            const hslAnimations = animationOptions;
            const h = (_e = (_d = particle.strokeColor) === null || _d === void 0 ? void 0 : _d.h) !== null && _e !== void 0 ? _e : (_f = particle.color) === null || _f === void 0 ? void 0 : _f.h;
            if (h) {
                this.updateValue(particle, delta, h, hslAnimations.h, 360);
            }
            const s = (_h = (_g = particle.strokeColor) === null || _g === void 0 ? void 0 : _g.s) !== null && _h !== void 0 ? _h : (_j = particle.color) === null || _j === void 0 ? void 0 : _j.s;
            if (s) {
                this.updateValue(particle, delta, s, hslAnimations.s, 100);
            }
            const l = (_l = (_k = particle.strokeColor) === null || _k === void 0 ? void 0 : _k.l) !== null && _l !== void 0 ? _l : (_m = particle.color) === null || _m === void 0 ? void 0 : _m.l;
            if (l) {
                this.updateValue(particle, delta, l, hslAnimations.l, 100);
            }
        }
    }
    updateValue(particle, delta, value, valueAnimation, max) {
        var _a;
        const colorValue = value;
        if (!colorValue) {
            return;
        }
        const offset = randomInRange(valueAnimation.offset);
        colorValue.value += ((_a = value.velocity) !== null && _a !== void 0 ? _a : 0) * delta.factor + offset * 3.6;
        if (colorValue.value > max) {
            colorValue.value %= max;
        }
    }
}
