"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Main = void 0;
const main_slim_1 = require("./main.slim");
const AbsorbersPlugin_1 = require("./Plugins/Absorbers/AbsorbersPlugin");
const EmittersPlugin_1 = require("./Plugins/Emitters/EmittersPlugin");
const PolygonMaskPlugin_1 = require("./Plugins/PolygonMask/PolygonMaskPlugin");
const TrailMaker_1 = require("./Interactions/External/TrailMaker");
const Lighter_1 = require("./Interactions/External/Lighter");
const Lighter_2 = require("./Interactions/Particles/Lighter");
const OrbitUpdater_1 = require("./Updaters/OrbitUpdater");
class Main extends main_slim_1.MainSlim {
    constructor() {
        super();
        this.addInteractor((container) => new Lighter_2.Lighter(container));
        this.addInteractor((container) => new Lighter_1.Lighter(container));
        this.addInteractor((container) => new TrailMaker_1.TrailMaker(container));
        this.addParticleUpdater((container) => new OrbitUpdater_1.OrbitUpdater(container));
        this.addPlugin(AbsorbersPlugin_1.AbsorbersPlugin);
        this.addPlugin(EmittersPlugin_1.EmittersPlugin);
        this.addPlugin(PolygonMaskPlugin_1.PolygonMaskPlugin);
    }
}
exports.Main = Main;
