"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MainSlim = void 0;
const SquareDrawer_1 = require("./ShapeDrawers/SquareDrawer");
const TextDrawer_1 = require("./ShapeDrawers/TextDrawer");
const ImageDrawer_1 = require("./ShapeDrawers/ImageDrawer");
const LineDrawer_1 = require("./ShapeDrawers/LineDrawer");
const CircleDrawer_1 = require("./ShapeDrawers/CircleDrawer");
const TriangleDrawer_1 = require("./ShapeDrawers/TriangleDrawer");
const StarDrawer_1 = require("./ShapeDrawers/StarDrawer");
const PolygonDrawer_1 = require("./ShapeDrawers/PolygonDrawer");
const Bouncer_1 = require("./Interactions/External/Bouncer");
const Bubbler_1 = require("./Interactions/External/Bubbler");
const Connector_1 = require("./Interactions/External/Connector");
const Grabber_1 = require("./Interactions/External/Grabber");
const Attractor_1 = require("./Interactions/External/Attractor");
const Repulser_1 = require("./Interactions/External/Repulser");
const Attractor_2 = require("./Interactions/Particles/Attractor");
const Collider_1 = require("./Interactions/Particles/Collider");
const Infecter_1 = require("./Interactions/Particles/Infecter");
const Repulser_2 = require("./Interactions/Particles/Repulser");
const Linker_1 = require("./Interactions/Particles/Linker");
const LifeUpdater_1 = require("./Updaters/LifeUpdater");
const OpacityUpdater_1 = require("./Updaters/OpacityUpdater");
const SizeUpdater_1 = require("./Updaters/SizeUpdater");
const AngleUpdater_1 = require("./Updaters/AngleUpdater");
const ColorUpdater_1 = require("./Updaters/ColorUpdater");
const StrokeColorUpdater_1 = require("./Updaters/StrokeColorUpdater");
const OutOfCanvasUpdater_1 = require("./Updaters/OutOfCanvasUpdater");
const main_core_1 = require("./main.core");
class MainSlim extends main_core_1.MainCore {
    constructor() {
        super();
        const squareDrawer = new SquareDrawer_1.SquareDrawer();
        const textDrawer = new TextDrawer_1.TextDrawer();
        const imageDrawer = new ImageDrawer_1.ImageDrawer();
        this.addParticleUpdater((container) => new LifeUpdater_1.LifeUpdater(container));
        this.addParticleUpdater((container) => new OpacityUpdater_1.OpacityUpdater(container));
        this.addParticleUpdater((container) => new SizeUpdater_1.SizeUpdater(container));
        this.addParticleUpdater((container) => new AngleUpdater_1.AngleUpdater(container));
        this.addParticleUpdater((container) => new ColorUpdater_1.ColorUpdater(container));
        this.addParticleUpdater((container) => new StrokeColorUpdater_1.StrokeColorUpdater(container));
        this.addParticleUpdater((container) => new OutOfCanvasUpdater_1.OutOfCanvasUpdater(container));
        this.addInteractor((container) => new Bouncer_1.Bouncer(container));
        this.addInteractor((container) => new Bubbler_1.Bubbler(container));
        this.addInteractor((container) => new Connector_1.Connector(container));
        this.addInteractor((container) => new Grabber_1.Grabber(container));
        this.addInteractor((container) => new Attractor_1.Attractor(container));
        this.addInteractor((container) => new Repulser_1.Repulser(container));
        this.addInteractor((container) => new Attractor_2.Attractor(container));
        this.addInteractor((container) => new Collider_1.Collider(container));
        this.addInteractor((container) => new Infecter_1.Infecter(container));
        this.addInteractor((container) => new Repulser_2.Repulser(container));
        this.addInteractor((container) => new Linker_1.Linker(container));
        this.addShape("line", new LineDrawer_1.LineDrawer());
        this.addShape("circle", new CircleDrawer_1.CircleDrawer());
        this.addShape("edge", squareDrawer);
        this.addShape("square", squareDrawer);
        this.addShape("triangle", new TriangleDrawer_1.TriangleDrawer());
        this.addShape("star", new StarDrawer_1.StarDrawer());
        this.addShape("polygon", new PolygonDrawer_1.PolygonDrawer());
        this.addShape("char", textDrawer);
        this.addShape("character", textDrawer);
        this.addShape("image", imageDrawer);
        this.addShape("images", imageDrawer);
    }
}
exports.MainSlim = MainSlim;
